//+---------------------------------------------------------------------------------+
//|                                       MTF_Ichimoku_v1ss[cw].mq4             ik  |
//| KijunLShift TenkanLShift KijunTenkanShift SenkouSpanShift ChinkouSpanShift Price                                        |
//| Kumo-lines;   leyers                           Copyright  2007, Forex-TSD.com   |
//| senkou&SenkouA_Shift"0"-leading kumo                                     Written by IgorAD,igorad2003@yahoo.co.uk   |   
//|                         http://finance.groups.yahoo.com/group/TrendLaboratory   |                                      
//+---------------------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DarkGreen
#property indicator_color2 Teal
#property indicator_color3 DarkSlateGray   //SSB2 - leading kumo 
#property indicator_color4 BlueViolet
#property indicator_color5 DarkSlateGray  //SSA2 -  leading kumo   
#property indicator_color6 MediumOrchid
#property indicator_color7 Maroon
#property indicator_color8 MediumBlue
#property indicator_width3 2
#property indicator_width4 2
//---- input parameters
extern int TimeFrame=0;
extern int Tenkan=9;
extern int Kijun=26;
extern int Senkou=52;
extern int TenkanLShift=1;   //linear shift
extern int KijunLShift=3;
extern int KTShift=0;
extern int SenkouSpanShift=0;
extern int SenkouSpanA_Shift=2;
extern int SenkouSpanB_Shift=4;
extern int ChinkouSpanShift=0;
extern int ____;
extern int ColorScheme_NextTab; 
extern int _______;
extern int ChinkouZen__DarkSlateGray__0;
extern int Chinkou_Buffer__DarkGreen___1;
extern int SenkouSpanB2_DarkSlateGray_2;
extern int SenkouSpanB__BlueViolet____3;
extern int SenkouSpanA2_DarkSlateGray_4;
extern int SenkouSpanA___Teal_____5;
extern int TenkanBuffer__Maroon____6; 
extern int KijunBuffer___MediumBlue__7;

//---- buffers
double Tenkan_Buffer[];
double Kijun_Buffer[];
double ChinkouZen_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   if(TimeFrame==0) TimeFrame = Period();   
//----
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,Tenkan_Buffer);
   SetIndexDrawBegin(6,Tenkan-1);
   SetIndexShift(6,(KTShift+TenkanLShift)*TimeFrame/Period());
   SetIndexLabel(6,"TenkanSen "+Tenkan+"tf"+TimeFrame+"ts"+TenkanLShift+"s"+KTShift+"");
//----
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,Kijun_Buffer);
   SetIndexDrawBegin(7,Kijun-1);
   SetIndexShift(7,(KTShift+KijunLShift)*TimeFrame/Period());
   SetIndexLabel(7,"KijunSen"+Kijun+"tf"+TimeFrame+"ks"+KijunLShift+"s"+KTShift+"");   
//----
   a_begin=Kijun; if(a_begin<Tenkan) a_begin=Tenkan;
  SetIndexStyle(4,0);
   SetIndexBuffer(4,SpanA_Buffer);
   SetIndexDrawBegin(4,Kijun+a_begin-1);
   if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(4,SenkouSpanA_Shift*TimeFrame/Period());
   SetIndexLabel(4,"SenkouSpanA(K+T/2)="+(Kijun+Tenkan)/2+"TF"+TimeFrame+"SAs"+SenkouSpanA_Shift+"");

   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,SpanA2_Buffer);
   SetIndexDrawBegin(5,Kijun+a_begin-1);
   SetIndexShift(5,Kijun*TimeFrame/Period()-SenkouSpanShift*TimeFrame/Period());
   SetIndexLabel(5,"SenkouSpanA2(K+T/2)="+(Kijun+Tenkan)/2+"TF"+TimeFrame+"ss"+SenkouSpanShift+"");

//----
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexBuffer(2,SpanB_Buffer);
   SetIndexDrawBegin(2,Kijun+Senkou-1);
   SetIndexShift(2,SenkouSpanB_Shift*TimeFrame/Period());
   SetIndexLabel(2,"SenkouSpanB "+Senkou+"TF"+TimeFrame+"SBs"+SenkouSpanB_Shift+"");

   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,SpanB2_Buffer);
   SetIndexDrawBegin(3,Kijun+Senkou-1);
   SetIndexShift(3,(Kijun)*TimeFrame/Period()-SenkouSpanShift*TimeFrame/Period()+1);
   SetIndexLabel(3,"SenkouSpanB2 "+Senkou+"TF"+TimeFrame+"ss"+SenkouSpanShift+"");
  
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ChinkouZen_Buffer);
   SetIndexShift(0,0);
   SetIndexLabel(0,"ChinkouZenSpan TF"+TimeFrame+"");

//----
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Chinkou_Buffer);
   SetIndexShift(1,-Kijun*TimeFrame/Period()+ChinkouSpanShift*TimeFrame/Period());
   SetIndexLabel(1,"ChinkouSpan TF"+TimeFrame+"cs"+ChinkouSpanShift+"");




   IndicatorShortName("MTF_Ichimoku_v1ss");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   datetime TimeArray[];
   int i,limit,y=0,counted_bars=IndicatorCounted();
   double high,low,price;
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame);

   limit=Bars-counted_bars+TimeFrame/Period();
   
   for(i=0,y=0;i<limit;i++) 
   {
   if (Time[i]<TimeArray[y]) y++;
   double UpTenkan = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Tenkan,y));
   double DnTenkan =  iLow(NULL,TimeFrame, iLowest(NULL,TimeFrame,MODE_LOW ,Tenkan,y));
   Tenkan_Buffer[i] = 0.5*(UpTenkan + DnTenkan);

   double UpKijun = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Kijun,y));
   double DnKijun =  iLow(NULL,TimeFrame, iLowest(NULL,TimeFrame,MODE_LOW ,Kijun,y));
   Kijun_Buffer[i] = 0.5*(UpKijun + DnKijun);
   
   double UpSenkou = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Senkou,y));
   double DnSenkou =  iLow(NULL,TimeFrame, iLowest(NULL,TimeFrame,MODE_LOW ,Senkou,y));
         
   SpanA_Buffer[i]= 0.5*(Kijun_Buffer[i]+Tenkan_Buffer[i]);
   SpanB_Buffer[i]= 0.5*(UpSenkou + DnSenkou);
   
   double chinkou=iClose(NULL,TimeFrame,y);
   if(chinkou>0) Chinkou_Buffer[i]=chinkou;
   
   double chinkouZen=iClose(NULL,TimeFrame,y);
   if(chinkouZen>0) ChinkouZen_Buffer[i]=chinkouZen;  
  
   SpanA2_Buffer[i]= SpanA_Buffer[i];
   SpanB2_Buffer[i]= SpanB_Buffer[i];
   }
return(0);
}